@ECHO OFF

SET VERSION=5.3

:loop
IF NOT "%1"=="" (
	IF "%1"=="-h" GOTO :help
	IF "%1"=="--help" GOTO :help
	IF "%1"=="-m" (
		SET MODULE="%2"
		SHIFT & SHIFT
		GOTO :loop
	)
	IF "%1"=="-i" (
		SET FIRMWARE_FILE=%2
		SHIFT & SHIFT
		GOTO :loop
	)
	IF "%1"=="-r" (
		SET FACTORYRESET_FILE=reset
		SHIFT
		GOTO :loop
	)
	ECHO.Unknown parameter "%1"
	SHIFT
	GOTO :loop
)

REM Checking firmware file
IF NOT "%FIRMWARE_FILE%"=="" GOTO :download

REM Checking reset file
IF NOT "%FACTORYRESET_FILE%"=="" GOTO :reset

:help
ECHO.
ECHO.NAME
ECHO.	swiflash.bat (version %VERSION%) - Tool to flash a Legato device
ECHO.
ECHO.USAGE
ECHO.	swiflash.bat -m <module> -i firmware.cwe
ECHO.
ECHO.OPTIONS
ECHO.	-h, --help
ECHO.		Display this message.
ECHO.
ECHO.	-m "MODULE"
ECHO.		Specifies the target module type.
ECHO.		Allowed values are: AR865X, AR755X, AR758X, WP85XX, WP750X, WP76XX, WP77XX, FX30(WP85XX)
ECHO.
ECHO.	-i FIRMWARE
ECHO.		Use this firmware image to flash the device.
ECHO.
ECHO.	-r
ECHO.		Restore the Linux root filesystem in its original state (all filesystem updates will be lost).
ECHO.		Note: This option is not supported on these modules: AR758X
ECHO.
GOTO :end

:download
REM Building FDT PATH
SET SCRIPTPATH=%CD%
SET FDTPATH=%SCRIPTPATH%\WINDOWS\FDT2.EXE
IF NOT EXIST %FDTPATH% GOTO :fdterr

REM Ready to download
ECHO.Checking image: %FIRMWARE_FILE%
IF NOT EXIST %FIRMWARE_FILE% GOTO :fwerr
cmd /c "start %FDTPATH% -f %FIRMWARE_FILE%"
goto :end

:reset
REM Building FDT PATH
SET SCRIPTPATH=%CD%
SET FDTPATH=%SCRIPTPATH%\WINDOWS\FDT2.EXE
IF NOT EXIST %FDTPATH% GOTO :fdterr

REM Ready to download
IF NOT EXIST %SCRIPTPATH%\%FACTORYRESET_FILE%\%MODULE%\reset.cwe GOTO :reseterr
cmd /c "start %FDTPATH% -f %SCRIPTPATH%\%FACTORYRESET_FILE%\%MODULE:"=%\reset.cwe"
goto :end

:fdterr
ECHO.FDT2.EXE download tool not found
goto :end

:fwerr
ECHO.Firmware image file not found
goto :end

:reseterr
ECHO.Option not supported for selected module (%MODULE%)
goto :end

:end
